scala.tools.nsc.transform.patmat.ScalacPatternExpanders

# alignPatterns

#### object alignPatterns extends ScalacPatternExpander

Source
  ScalacPatternExpanders.scala

Linear Supertypes
ScalacPatternExpander, PatternExpander[Global.Tree, Global.Type], AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. alignPatterns
2. ScalacPatternExpander
3. PatternExpander
4. AnyRef
5. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### final case class Aligned(patterns: Patterns, extractor: Extractor) extends Product with Serializable

   If elementArity is...

   If elementArity is... 0: A perfect match between extractor and the fixed patterns. If there is a star pattern it will match any sequence. > 0: There are more patterns than products. There will have to be a sequence which can populate at least <elementArity> patterns. < 0: There are more products than patterns: compile time error.

   Definition Classes
     PatternExpander

2. #### final case class Extractor(whole: Type, fixed: List[Type], repeated: Repeated) extends Product with Serializable

   An 'extractor' can be a case class or an unapply or unapplySeq method.

   An 'extractor' can be a case class or an unapply or unapplySeq method. Decoding what it is that they extract takes place before we arrive here, so that this class can concentrate only on the relationship between patterns and types.

   In a case class, the class is the unextracted type and the fixed and repeated types are derived from its constructor parameters.

   In an unapply, this is reversed: the parameter to the unapply is the unextracted type, and the other types are derived based on the return type of the unapply method.

   In other words, this case class and unapply are encoded the same:

   case class Foo(x: Int, y: Int, zs: Char*) def unapplySeq(x: Foo): Option[(Int, Int, Seq[Char])]

   Both are Extractor(Foo, Int :: Int :: Nil, Repeated(Seq[Char], Char, Char*))

   whole

     The type in its unextracted form

   fixed

     The non-sequence types which are extracted

   repeated

     The sequence type which is extracted

   Definition Classes
     PatternExpander

3. #### final case class Patterns(fixed: List[Pattern], star: Pattern) extends Product with Serializable

   Definition Classes
     PatternExpander

4. #### sealed case class Repeated(sequenceType: Type, elementType: Type, repeatedType: Type) extends Product with Serializable

   It's not optimal that we're carrying both sequence and repeated type here, but the implementation requires more unraveling before it can be avoided.

   It's not optimal that we're carrying both sequence and repeated type here, but the implementation requires more unraveling before it can be avoided.

   sequenceType is Seq[T], elementType is T, repeatedType is T*.

   Definition Classes
     PatternExpander

5. #### final case class TypedPat(pat: Pattern, tpe: Type) extends Product with Serializable

   Definition Classes
     PatternExpander

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def NoPattern: Global.EmptyTree.type

   You'll note we're not inside the cake.

   You'll note we're not inside the cake. "Pattern" and "Type" are arbitrary types here, and NoPattern and NoType arbitrary values.

   Definition Classes
     ScalacPatternExpander → PatternExpander

5. #### object NoRepeated extends Repeated

   Definition Classes
     PatternExpander

6. #### def NoType: Global.NoType.type

   Definition Classes
     ScalacPatternExpander → PatternExpander

7. #### def apply(context: (analyzer)#Context, tree: Global.Tree): Aligned

8. #### def apply(context: (analyzer)#Context, sel: Global.Tree, args: List[Global.Tree]): Aligned

9. #### def applyMethodTypes(method: Global.Type): Extractor

   In this case we are basing the pattern expansion on a case class constructor.

   In this case we are basing the pattern expansion on a case class constructor. The argument is the MethodType carried by the primary constructor.

   Definition Classes
     ScalacPatternExpander

10. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

11. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

12. #### def elementTypeOf(tpe: Global.Type): Global.Type

    Definition Classes
      ScalacPatternExpander

13. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

16. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

17. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

20. #### def newExtractor(whole: Global.Type, fixed: List[Global.Type], repeated: Repeated): Extractor

    Definition Classes
      ScalacPatternExpander

21. #### def newPatterns(patterns: List[Global.Tree]): Patterns

    Definition Classes
      ScalacPatternExpander

22. #### final def notify(): Unit

    Definition Classes
      AnyRef

23. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

24. #### def repeatedFromSeq(seqType: Global.Type): Repeated

    Definition Classes
      ScalacPatternExpander

25. #### def repeatedFromVarargs(repeated: Global.Type): Repeated

    Definition Classes
      ScalacPatternExpander

26. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

27. #### def toString(): String

    Definition Classes
      AnyRef → Any

28. #### def tupleExtractor(extractor: Extractor): Extractor

    Converts a T => (A, B, C) extractor to a T => ((A, B, CC)) extractor.

29. #### def unapplyMethodTypes(method: Global.Type, isSeq: Boolean): Extractor

    In this case, expansion is based on an unapply or unapplySeq method.

    In this case, expansion is based on an unapply or unapplySeq method. Unfortunately the MethodType does not carry the information of whether it was unapplySeq, so we have to funnel that information in separately.

    Definition Classes
      ScalacPatternExpander

30. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

31. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

32. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from ScalacPatternExpander

### Inherited from PatternExpander[Global.Tree, Global.Type]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped